Magellan Linux

Diff of /branches/mage-next/src/smage2.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 1572 by niro, Wed Dec 28 10:31:45 2011 UTC revision 1593 by niro, Thu Dec 29 15:20:20 2011 UTC
# Line 10  Line 10 
10  # set default user mage.rc  # set default user mage.rc
11  : ${MAGERC="/etc/mage.rc"}  : ${MAGERC="/etc/mage.rc"}
12    
 ## setup ##  
 SMAGENAME="$1"  
 SMAGEVERSION="$( < ${MLIBDIR}/version)"  
   
13  # export default C locale  # export default C locale
14  export LC_ALL=C  export LC_ALL=C
15    
# Line 21  source /etc/mage.rc.global Line 17  source /etc/mage.rc.global
17  source ${MAGERC}  source ${MAGERC}
18  source ${MLIBDIR}/mage4.functions.sh  source ${MLIBDIR}/mage4.functions.sh
19    
20    ## setup ##
21    SMAGENAME="$1"
22    SMAGEVERSION="$(< ${MLIBDIR}/version)"
23    
24  # set PKGDIR and BUILDDIR and BINDIR to MROOT  # set PKGDIR and BUILDDIR and BINDIR to MROOT
25  if [[ -n ${MROOT} ]]  if [[ -n ${MROOT} ]]
26  then  then
# Line 139  get_db_md5_sum() Line 139  get_db_md5_sum()
139    
140  download_sources()  download_sources()
141  {  {
   
142   [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0   [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0
143    
144   local EOA=${#SRC_URI[*]}   local count=${#SRC_URI[*]}
145   local my_SRC_URI   local uri
146   local my_SRC_URI_DEST   local subdir
147   local my_SRC_URI_MIRROR   local outputdir
148   local my_SOURCEDIR   local db_md5_file="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"
149   local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"   local fetching
150   local FETCHING   local i
  local i mirror  
  local wget_opts  
   
  # filter wget command if busybox was found  
  wget_opts="$(busybox_filter_wget_options ${WGET_FETCH_OPTIONS})"  
   
  # install SRCDIR/PNAME if not exist  
  [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}  
151    
152   # check if FETCHING is needed   # check if FETCHING is needed
153   ( cd ${SOURCEDIR}/${PNAME}; md5sum -c ${DB_MD5_SUM_FILE} &> /dev/null )   if mchecksum --rundir "${SOURCEDIR}/${PNAME}" --file "${db_md5_file}" --method md5
  if [[ $? = 0 ]]  
154   then   then
155   # md5's ok, no fetching needed   # md5's ok, no fetching needed
156   FETCHING=false   fetching=false
157   else   else
158   FETCHING=true   fetching=true
159   fi   fi
160    
161   for ((i=0; i < EOA; i++))   if [[ ${fetching} = true ]]
162   do   then
163   # url to file   for ((i=0; i < count; i++))
164   my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"   do
165     # url to file
166   # subdir in sources dir; the my_SRCI_URI file goes to there   uri="${SRC_URI[${i}]%%' '*}"
  my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"  
   
  # if my_src_uri_dest is not equal my_src_uri; than an other dir is used  
  if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]  
  then  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"  
  else  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}"  
  fi  
   
  # create the SOURCEDIR  
  install -d ${my_SOURCEDIR}  
   
  # if an mirrored file than replace first the mirror uri  
  if [[ -n $(echo ${my_SRC_URI} | grep 'mirror://') ]]  
  then  
  for mirror in ${MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  ${wget_opts} \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'sourceforge://') ]]  
  then  
  for mirror in ${SOURCEFORGE_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|sourceforge:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  ${wget_opts} \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'gnu://') ]]  
  then  
  for mirror in ${GNU_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|gnu:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  ${wget_opts} \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'kde://') ]]  
  then  
  for mirror in ${KDE_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|kde:/|${mirror}|g")"  
167    
168   if [[ ${FETCHING} = true ]]   # subdir in sources dir; the my_SRCI_URI file goes to there
169   then   subdir="${SRC_URI[${i}]##*' '}"
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  ${wget_opts} \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'gnome://') ]]  
  then  
  for mirror in ${GNOME_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|gnome:/|${mirror}|g")"  
170    
171   if [[ ${FETCHING} = true ]]   # if $subdir is not equal with $uri then an other dir is used
172   then   if [[ ${uri} != ${subdir} ]]
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  ${wget_opts} \  
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI_MIRROR})" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  else  
  if [[ ${FETCHING} = true ]]  
173   then   then
174   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI}${COLDEFAULT}"   outputdir="${SOURCEDIR}/${PNAME}/${subdir}"
175   wget \   else
176   ${wget_opts} \   outputdir="${SOURCEDIR}/${PNAME}"
  --output-document="${my_SOURCEDIR}/$(basename ${my_SRC_URI})" \  
  "${my_SRC_URI}"  
177   fi   fi
  fi  
178    
179   # unset them to be shure   echo -e "${COLBLUE}==>${COLGREEN} fetching ${uri}${COLDEFAULT}"
180   unset my_SRC_URI   mdownload --uri "${uri}" --dir "${outputdir}" || die "Could not download '${uri}'"
  unset my_SRC_URI_DEST  
  unset my_SRC_URI_MIRROR  
  unset my_SOURCEDIR  
  done  
181    
182   # recheck md5 sums   # unset them to be sure
183   echo   unset uri
184   echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"   unset subdir
185   ( cd ${SOURCEDIR}/${PNAME}; md5sum -c ${DB_MD5_SUM_FILE} ) || die "md5 failed"   unset outputdir
186   echo   done
187    
188     # recheck md5 sums after download
189     echo
190     echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"
191     mchecksum --rundir "${SOURCEDIR}/${PNAME}" --file "${db_md5_file}" --method md5 || die "md5 failed"
192     echo
193     else
194     echo -e "${COLBLUE}===${COLGREEN} All sources already fetched, nothing to do${COLDEFAULT}"
195     fi
196    
197   # not needed anymore   # not needed anymore
198   unset SRC_URI   unset SRC_URI
199  }  }
200    
201  # dummy function, used if that not exist in smage file  # dummy function, used if that does not exist in smage file
202  src_prepare()  src_prepare()
203  {  {
204   echo "no src_prepare defined"   echo "no src_prepare defined; doing nothing ..."
  sleep 2  
205   return 0   return 0
206  }  }
207    
208  # dummy function, used if that not exist in smage file  # dummy function, used if that does not exist in smage file
209  src_compile()  src_compile()
210  {  {
211   echo "no src_compile defined"   echo "no src_compile defined; doing nothing ..."
  sleep 2  
212   return 0   return 0
213  }  }
214    
215  # dummy function, used if that not exist in smage file  # dummy function, used if that does not exist in smage file
216    src_check()
217    {
218     echo "no src_check defined; doing nothing ..."
219     return 0
220    }
221    
222    # dummy function, used if that does not exist in smage file
223  src_install()  src_install()
224  {  {
225   echo "no src_install defined"   echo "no src_install defined; doing nothing ..."
  sleep 2  
226   return 0   return 0
227  }  }
228    
# Line 528  mautoreconf() Line 409  mautoreconf()
409  minstalldocs()  minstalldocs()
410  {  {
411   local docfiles   local docfiles
412     local doc
413   docfiles="$@"   docfiles="$@"
414    
415   if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]   if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]
# Line 535  minstalldocs() Line 417  minstalldocs()
417   install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."   install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."
418   fi   fi
419    
420   local i   for doc in ${docfiles}
  for i in ${docfiles}  
421   do   do
422   if [ -f ${i} ]   if [ -f ${doc} ]
423   then   then
424   cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."   if mqueryfeature "compressdoc"
425   install -m 0644 ${SRCDIR}/${i}.gz \   then
426   ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."   cat ${doc} | gzip -9c > ${BINDIR}/usr/share/doc/${PNAME}-${PVER}/${doc}.gz || die "gzipping +installing ${doc}."
427     chmod 0644 ${BINDIR}/usr/share/doc/${PNAME}-${PVER}/${doc}.gz || die "fixing permissions of ${doc}."
428     else
429     install -m 0644 ${SRCDIR}/${i} ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "installing ${doc}."
430     fi
431   fi   fi
432   done   done
433  }  }
# Line 551  mstriplibs() Line 436  mstriplibs()
436  {  {
437   local stripdir="$@"   local stripdir="$@"
438    
439   [ -z "${stripdir}" ] && stripdir=${BINDIR}   [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
440   find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip ${STRIP_DYN_LIB} 2> /dev/null   [[ -z ${STRIP_DYN_LIB} ]] && STRIP_DYN_LIB="--strip-debug"
441     find ${stripdir} ! -type d | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_LIB} 2> /dev/null
442  }  }
443    
444  mstripbins()  mstripbins()
445  {  {
446   local stripdir="$@"   local stripdir="$@"
447    
448   [ -z "${stripdir}" ] && stripdir=${BINDIR}   [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
449   find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip ${STRIP_DYN_BIN} 2> /dev/null   [[ -z ${STRIP_DYN_BIN} ]] && STRIP_DYN_BIN="--strip-debug"
450     find ${stripdir} ! -type d | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_BIN} 2> /dev/null
451  }  }
452    
453  mstripstatic()  mstripstatic()
454  {  {
455   local stripdir="$@"   local stripdir="$@"
456    
457   [ -z "${stripdir}" ] && stripdir=${BINDIR}   [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
458   find ${stripdir} | xargs file | grep "ar archive" | cut -f 1 -d : | xargs strip ${STRIP_STATIC_LIB} 2> /dev/null   [[ -z ${STRIP_STATIC_LIB} ]] && STRIP_STATIC_LIB="--strip-debug"
459     find ${stripdir} ! -type d | xargs file | grep "ar archive" | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_STATIC_LIB} 2> /dev/null
460    }
461    
462    mstriplibtoolarchive()
463    {
464     local stripdir="$@"
465    
466     [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
467     find ${stripdir} ! -type d -name \*.la | xargs file | grep "libtool library" | cut -f 1 -d : | xargs --no-run-if-empty rm -f -- 2> /dev/null
468    }
469    
470    mpurgetargets()
471    {
472     local stripdir="$@"
473     local target
474    
475     [[ -z ${stripdir} ]] && stripdir=${BINDIR}
476     # nothing to do in this case
477     [[ -z ${PURGE_TARGETS[*]} ]] && return
478    
479     for target in ${PURGE_TARGETS[*]}
480     do
481     # check if target is a regex pattern without any slashes
482     if [[ ${target} = ${target//\/} ]]
483     then
484     find ${BINDIR} -type f -name "${target}" | xargs --no-run-if-empty rm -f -- 2> /dev/null
485     else
486     rm -f -- ${target} 2> /dev/null
487     fi
488     done
489  }  }
490    
491  mcompressdocs()  mcompressdocs()
# Line 627  setup_ccache_environment() Line 544  setup_ccache_environment()
544   fi   fi
545  }  }
546    
   
547  # fixes given dependencies to match a MAGE_TARGET  # fixes given dependencies to match a MAGE_TARGET
548  # fix_mage_deps -target s/depend # <-- note -target !  # fix_mage_deps -target s/depend # <-- note -target !
549  fix_mage_deps()  fix_mage_deps()
# Line 814  regen_mage_tree() Line 730  regen_mage_tree()
730   local subpackage   local subpackage
731    
732   # build them only if requested   # build them only if requested
733   if [[ ${REGEN_MAGE_TREE} = true ]]   if mqueryfeature regentree
734   then   then
735   # run it without targets   # run it without targets
736   if [[ -n ${MAGE_TARGETS} ]]   if [[ -n ${MAGE_TARGETS} ]]
# Line 903  split_save_variables() Line 819  split_save_variables()
819   export SAVED_DEPEND="${DEPEND}"   export SAVED_DEPEND="${DEPEND}"
820   export SAVED_SDEPEND="${SDEPEND}"   export SAVED_SDEPEND="${SDEPEND}"
821   export SAVED_PROVIDE="${PROVIDE}"   export SAVED_PROVIDE="${PROVIDE}"
822   export SAVED_NOPKGBUILD="${NOPKGBUILD}"   export SAVED_PKGTYPE="${PKGTYPE}"
823    
824     # special handling needed for mage features
825     # pkgbuild
826     mqueryfeature "pkgbuild" && export SAVED_FEATURE_PKGBUILD="pkgbuild"
827     mqueryfeature "!pkgbuild" && export SAVED_FEATURE_PKGBUILD="!pkgbuild"
828     # strip
829     mqueryfeature "strip" && export SAVED_FEATURE_STRIP="strip"
830     mqueryfeature "!strip" && export SAVED_FEATURE_STRIP="!strip"
831     # libtool
832     mqueryfeature "libtool" && export SAVED_FEATURE_LIBTOOL="libtool"
833     mqueryfeature "!libtool" && export SAVED_FEATURE_LIBTOOL="!libtool"
834     # compressdoc
835     mqueryfeature "compressdoc" && export SAVED_FEATURE_COMPRESSDOC="compressdoc"
836     mqueryfeature "!compressdoc" && export SAVED_FEATURE_COMPRESSDOC="!compressdoc"
837    
838   # bindir too   # bindir too
839   export SAVED_BINDIR="${BINDIR}"   export SAVED_BINDIR="${BINDIR}"
# Line 964  split_restore_variables() Line 894  split_restore_variables()
894   export DEPEND="${SAVED_DEPEND}"   export DEPEND="${SAVED_DEPEND}"
895   export SDEPEND="${SAVED_SDEPEND}"   export SDEPEND="${SAVED_SDEPEND}"
896   export PROVIDE="${SAVED_PROVIDE}"   export PROVIDE="${SAVED_PROVIDE}"
897   export NOPKGBUILD="${SAVED_NOPKGBUILD}"   export PKGTYPE="${SAVED_PKGTYPE}"
898    
899     # special handling needed for mage features
900     # pkgbuild
901     msetfeature "${SAVED_FEATURE_PKGBUILD}"
902     # strip
903     msetfeature "${SAVED_FEATURE_STRIP}"
904     # libtool
905     msetfeature "${SAVED_FEATURE_LIBTOOL}"
906     # compressdoc
907     msetfeature "${SAVED_FEATURE_COMPRESSDOC}"
908    
909   # bindir too   # bindir too
910   export BINDIR="${SAVED_BINDIR}"   export BINDIR="${SAVED_BINDIR}"
# Line 1024  split_unset_variables() Line 964  split_unset_variables()
964   unset SAVED_SDEPEND   unset SAVED_SDEPEND
965   unset SAVED_PROVIDE   unset SAVED_PROVIDE
966   unset SAVED_BINDIR   unset SAVED_BINDIR
967   unset SAVED_NOPKGBUILD   unset SAVED_PKGTYPE
968     unset SAVED_FEATURE_PKGBUILD
969     unset SAVED_FEATURE_STRIP
970     unset SAVED_FEATURE_LIBTOOL
971     unset SAVED_FEATURE_COMPRESSDOC
972   unset SPLIT_PACKAGE_BASE   unset SPLIT_PACKAGE_BASE
973   unset -f SAVED_preinstall   unset -f SAVED_preinstall
974   unset -f SAVED_postinstall   unset -f SAVED_postinstall
# Line 1124  generate_package_md5sum() Line 1068  generate_package_md5sum()
1068   # fix target as it may be empty !   # fix target as it may be empty !
1069   [ -n "${target}" ] && target="-${target}"   [ -n "${target}" ] && target="-${target}"
1070    
   
1071   # build pkgname   # build pkgname
1072   pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"   pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"
1073    
1074   # build pkg-md5-sum only if requested   # build pkg-md5-sum only if requested
1075   if [[ ${REGEN_MAGE_TREE} = true ]]   if mqueryfeature regentree
1076   then   then
1077   echo -ne "${COLBLUE}===${COLGREEN} generating md5's for ${pkgname}.${PKGSUFFIX} ... ${COLDEFAULT}"   echo -ne "${COLBLUE}===${COLGREEN} generating md5's for ${pkgname}.${PKGSUFFIX} ... ${COLDEFAULT}"
1078    
# Line 1184  source_pkg_build() Line 1127  source_pkg_build()
1127    
1128  step_by_step()  step_by_step()
1129  {  {
1130   if [[ ${STEP_BY_STEP} = true ]]   if mqueryfeature stepbystep
1131   then   then
1132   echo -e "${COLRED}Step-by-step enabled! Paused after $1.${COLDEFAULT}"   echo -e "${COLRED}Step-by-step enabled! Paused after $1.${COLDEFAULT}"
1133   echo "Press [enter] to continue"   echo "Press [enter] to continue"
# Line 1204  then Line 1147  then
1147   exit 1   exit 1
1148  fi  fi
1149    
1150    # load supported mage features
1151    load_mage_features
1152    
1153  # updating smage2-scripts  # updating smage2-scripts
1154  if [[ $1 = update ]]  if [[ $1 = update ]]
1155  then  then
# Line 1388  fi Line 1334  fi
1334  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
1335  then  then
1336   SRCPKGTARBALL="${2}"   SRCPKGTARBALL="${2}"
1337   USE_SRC_PKG_TARBALL=true   msetfeature "srcpkgtarball"
1338    
1339   # abort if given file is not a source pkg   # abort if given file is not a source pkg
1340   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
# Line 1432  echo -e "${COLGREEN}Compiling ${PKGNAME} Line 1378  echo -e "${COLGREEN}Compiling ${PKGNAME}
1378  # auto regen mage tree if requested  # auto regen mage tree if requested
1379  regen_mage_tree  regen_mage_tree
1380    
1381  if [[ ${CREATE_SRC_PKG_TARBALL} = true ]]  if mqueryfeature "srcpkg"
1382  then  then
1383   if [[ -d ${SOURCEDIR}/${PNAME} ]]   if [[ -d ${SOURCEDIR}/${PNAME} ]]
1384   then   then
# Line 1442  then Line 1388  then
1388  fi  fi
1389    
1390  # download sources  # download sources
1391  [[ ${USE_SRC_PKG_TARBALL} != true ]] && download_sources  mqueryfeature "srcpkgtarball" || download_sources
1392    
1393  # fixes some issues with these functions  # fixes some issues with these functions
1394  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
1395  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
1396    export -f src_check || die "src_check export failed"
1397  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
1398    
1399  # fixes some compile issues  # fixes some compile issues
# Line 1456  export CXXFLAGS="${CFLAGS}" || die "CXXF Line 1403  export CXXFLAGS="${CFLAGS}" || die "CXXF
1403  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
1404  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
1405    
   
1406  # setup distcc  # setup distcc
1407  # setup for distcc goes *before* ccache, so ccache comes before distcc in path  # setup for distcc goes *before* ccache, so ccache comes before distcc in path
1408  [[ ${SMAGE_USE_DISTCC} = true ]] && setup_distcc_environment  mqueryfeature "distcc" && setup_distcc_environment
1409    
1410  # setup ccache  # setup ccache
1411  [[ ${SMAGE_USE_CCACHE} = true ]] && setup_ccache_environment  mqueryfeature "ccache" && setup_ccache_environment
   
 # small sleep to show our settings  
 sleep 1  
1412    
1413  # cleans up build if a previously one exists  # clean up builddir if a previously one exist
1414  if [ -d ${BUILDDIR} ]  if [ -d ${BUILDDIR} ]
1415  then  then
1416   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
1417  fi  fi
1418  install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
1419    
1420  # cleans up srcdir if a previously unpacked one exists  # clean up srcdir if a previously unpacked one exist
1421  if [ -d ${SRCDIR} ]  if [ -d ${SRCDIR} ]
1422  then  then
1423   rm -rf ${SRCDIR}   rm -rf ${SRCDIR}
1424  fi  fi
1425    
1426  # cleans up bindir if a previous build exists or creates a new one  # clean up bindir if a previous build exist or create a new one
1427  if [ -d ${BINDIR} ]  if [ -d ${BINDIR} ]
1428  then  then
1429   rm -rf ${BINDIR}   rm -rf ${BINDIR}
1430  fi  fi
1431  install -d ${BINDIR} || die "couldn't create \$BINDIR."  install -d ${BINDIR} || die "couldn't create \$BINDIR."
1432    
1433  # cleans up package temp dir if a previous build exists  # clean up package temp dir if a previous build exist
1434  if [ -d ${BUILDDIR}/${PKGNAME} ]  if [ -d ${BUILDDIR}/${PKGNAME} ]
1435  then  then
1436   rm -rf ${BUILDDIR}/${PKGNAME}   rm -rf ${BUILDDIR}/${PKGNAME}
1437  fi  fi
1438    
1439  # cleans up timestamp if one exists  # setup build logging
 if [ -f /var/tmp/timestamp ]  
 then  
  mage rmstamp  
 fi  
   
 # setup build loggins  
1440  [[ ! -d /var/log/smage ]] && install -d /var/log/smage  [[ ! -d /var/log/smage ]] && install -d /var/log/smage
1441  echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log  echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
1442    
1443  src_prepare | ${SMAGE_LOG_CMD}  if [[ ${PKGTYPE} = virtual ]]
 die_pipestatus 0 "src_prepare failed"  
 step_by_step $_  
   
 src_compile | ${SMAGE_LOG_CMD}  
 die_pipestatus 0 "src_compile failed"  
 step_by_step $_  
   
 # build several subpackages  
 if [[ -n ${SPLIT_PACKAGES} ]]  
1444  then  then
1445   # save bindir & pname   echo "virtual package detected; nothing will be build ..."
1446   split_save_variables   # automatically set !pkgbuild here too
1447   export SAVED_BINDIR="${BINDIR}"   msetfeature "!pkgbuild"
  for subpackage in ${SPLIT_PACKAGES}  
  do  
  if typeset -f src_install_${subpackage} > /dev/null  
  then  
  # export subpackage bindir  
  export BINDIR="${SAVED_BINDIR}_${subpackage}"  
  # export PNAME, several internal function and include  
  # rely on this variable  
  export PNAME="${subpackage}"  
   
  echo  
  echo -en "${COLBLUE}*** ${COLDEFAULT}"  
  echo -en "  Running ${COLGREEN}split src_install()${COLDEFAULT}"  
  echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"  
  echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."  
   
  src_install_${subpackage} | ${SMAGE_LOG_CMD}  
  die_pipestatus 0 "src_install_${subpackage} failed"  
  step_by_step $_  
  fi  
  done  
  # restore bindir & pname  
  split_restore_variables  
  # unset all saved smage variables  
  split_unset_variables  
1448  else  else
1449   src_install | ${SMAGE_LOG_CMD}   src_prepare | ${SMAGE_LOG_CMD}
1450   die_pipestatus 0 "src_install failed"   die_pipestatus 0 "src_prepare failed"
1451   step_by_step $_   step_by_step $_
1452    
1453     src_compile | ${SMAGE_LOG_CMD}
1454     die_pipestatus 0 "src_compile failed"
1455     step_by_step $_
1456    
1457     # only run checks if requested
1458     if mqueryfeature "!check"
1459     then
1460     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
1461     step_by_step src_check
1462     else
1463     src_check | ${SMAGE_LOG_CMD}
1464     die_pipestatus 0 "src_check failed"
1465     step_by_step $_
1466     fi
1467    
1468     # build several subpackages
1469     if [[ -n ${SPLIT_PACKAGES} ]]
1470     then
1471     # save bindir & pname
1472     split_save_variables
1473     export SAVED_BINDIR="${BINDIR}"
1474     for subpackage in ${SPLIT_PACKAGES}
1475     do
1476     if typeset -f src_install_${subpackage} > /dev/null
1477     then
1478     # export subpackage bindir
1479     export BINDIR="${SAVED_BINDIR}_${subpackage}"
1480     # export PNAME, several internal function and include
1481     # rely on this variable
1482     export PNAME="${subpackage}"
1483    
1484     echo
1485     echo -en "${COLBLUE}*** ${COLDEFAULT}"
1486     echo -en "  Running ${COLGREEN}split src_install()${COLDEFAULT}"
1487     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
1488     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
1489    
1490     src_install_${subpackage} | ${SMAGE_LOG_CMD}
1491     die_pipestatus 0 "src_install_${subpackage} failed"
1492     step_by_step $_
1493     fi
1494     done
1495     # restore bindir & pname
1496     split_restore_variables
1497     # unset all saved smage variables
1498     split_unset_variables
1499     else
1500     src_install | ${SMAGE_LOG_CMD}
1501     die_pipestatus 0 "src_install failed"
1502     step_by_step $_
1503     fi
1504  fi  fi
1505    
1506  # compressing doc, info & man files  # echo for sake of good-looking
1507  if [[ -n ${SPLIT_PACKAGES} ]]  echo
1508    
1509    if mqueryfeature "!compressdoc"
1510  then  then
1511   for subpackage in ${SPLIT_PACKAGES}   echo -e "!compressdoc detected; documentation will not be compressed ..."
  do  
  mcompressdocs ${BINDIR}_${subpackage}  
  done  
1512  else  else
1513   mcompressdocs ${BINDIR}   # compressing doc, info & man files
1514     if [[ -n ${SPLIT_PACKAGES} ]]
1515     then
1516     for subpackage in ${SPLIT_PACKAGES}
1517     do
1518     mcompressdocs ${BINDIR}_${subpackage}
1519     done
1520     else
1521     mcompressdocs ${BINDIR}
1522     fi
1523  fi  fi
1524    
1525    if mqueryfeature "!libtool"
1526    then
1527     if [[ -n ${SPLIT_PACKAGES} ]]
1528     then
1529     for subpackage in ${SPLIT_PACKAGES}
1530     do
1531     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
1532     mstriplibtoolarchive ${BINDIR}_${subpackage}
1533     done
1534     else
1535     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
1536     mstriplibtoolarchive ${BINDIR}
1537     fi
1538    fi
1539    
1540    if mqueryfeature "purge"
1541    then
1542     if [[ -n ${SPLIT_PACKAGES} ]]
1543     then
1544     for subpackage in ${SPLIT_PACKAGES}
1545     do
1546     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
1547     mpurgetargets ${BINDIR}_${subpackage}
1548     done
1549     else
1550     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
1551     mpurgetargets ${BINDIR}
1552     fi
1553    fi
1554    
1555  # stripping all bins and libs  # stripping all bins and libs
1556  case ${NOSTRIP} in  if mqueryfeature "!strip"
1557   true|TRUE|yes|y)  then
1558   echo -e "NOSTRIP=true detected; Package will not be stripped ..."   echo -e "!strip detected; Package will not be stripped ..."
1559   ;;  else
  *)  
1560   if [[ -n ${SPLIT_PACKAGES} ]]   if [[ -n ${SPLIT_PACKAGES} ]]
1561   then   then
1562   for subpackage in ${SPLIT_PACKAGES}   for subpackage in ${SPLIT_PACKAGES}
# Line 1585  case ${NOSTRIP} in Line 1576  case ${NOSTRIP} in
1576   echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"   echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
1577   mstripstatic ${BINDIR}   mstripstatic ${BINDIR}
1578   fi   fi
1579   ;;  fi
 esac  
1580    
1581  # the new buildpkg command  if mqueryfeature "!buildpkg"
1582  case ${NOPKGBUILD} in  then
1583   true|TRUE|yes|y)   echo -e "!buildpkg detected; Package will not be build ..."
1584   echo -e "NOPGKBUILD=true detected; Package will not be build ..."  else
  ;;  
  *)  
1585   # build several targets   # build several targets
1586   if [[ -n ${MAGE_TARGETS} ]]   if [[ -n ${MAGE_TARGETS} ]]
1587   then   then
1588   for target in ${MAGE_TARGETS}   for target in ${MAGE_TARGETS}
1589   do   do
1590   # check if an special target_pkgbuild exists   # check if a special target_pkgbuild exists
1591   if typeset -f ${target}_pkgbuild > /dev/null   if typeset -f ${target}_pkgbuild > /dev/null
1592   then   then
1593   # run it   # run it
# Line 1632  case ${NOPKGBUILD} in Line 1620  case ${NOPKGBUILD} in
1620   export PNAME="${subpackage}"   export PNAME="${subpackage}"
1621   split_info_${PNAME}   split_info_${PNAME}
1622    
1623   # jump to next one if NOPKGBUILD is set in split_info   # jump to next one if !buildpkg is set in split_info
1624   case ${NOPKGBUILD} in   mqueryfeature "!buildpkg" && continue
  true|TRUE|yes|y) continue ;;  
  esac  
1625    
1626   # check if an special subpackage_pkgbuild exists   # check if an special subpackage_pkgbuild exists
1627   if typeset -f ${PNAME}_pkgbuild > /dev/null   if typeset -f ${PNAME}_pkgbuild > /dev/null
# Line 1679  case ${NOPKGBUILD} in Line 1665  case ${NOPKGBUILD} in
1665   fi   fi
1666    
1667   # build src-pkg-tarball if requested   # build src-pkg-tarball if requested
1668   [[ ${CREATE_SRC_PKG_TARBALL} = true ]] && source_pkg_build ${SMAGENAME}   mqueryfeature "srcpkg" && source_pkg_build ${SMAGENAME}
1669   ;;  fi
 esac  
1670    
1671  if [[ ${SMAGE_BUILD_LOGGING} != false ]]  if mqueryfeature "buildlog"
1672  then  then
1673   bzip2 -9f /var/log/smage/${PKGNAME}.log   bzip2 -9f /var/log/smage/${PKGNAME}.log
1674  else  else
1675   [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log   [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
1676  fi  fi
1677    
 # for sure  
 unset NOPKGBUILD  
 unset NOSTRIP  
   
1678  xtitleclean  xtitleclean

Legend:
Removed from v.1572  
changed lines
  Added in v.1593